#ifndef _UNICODE_H
#define _UNICODE_H 1

#include <evblib/str/str.h>

/* UVL/UTF-8 support routines. Not complete, but due to the templated
   decoder and encoder, more targets and sources are trivial to add in 
   utf8.c. */

/* decoding */

int utf8len(char *s, int sl, int *ret_taken);

int utf8to16be(char *s, int sl, char *d, int dl, int *ret_taken);
int utf8to32ho(char *s, int sl, uint32_t *d, int dc, int *ret_taken);

STR_T utf8to16bestr(char *p, int l);

int uvlto32ho(char *s, int sl, uint32_t *d, int dc, int *ret_taken);

int32_t getuvl(char *s, int sl, int *ret_taken);

/* encoding */

int utf8from32ho(char *d, int dl, uint32_t *s, int sc, int *ret_sc_left);

#endif

/*
 * vim:softtabstop=4:sw=4
 */

